Package: RELIEF
Type: Package
Title: RELIEF harmonization for removing latent patch effects
Version: 0.1.0
Author: Jun Young Park, Rongqian Zhang
Maintainer: Jun Young Park <junjy.park@utronto.ca>
Description: TBD
License: GPL-3
Encoding: UTF-8
Depends: Matrix, MASS, denoiseR
 

<p align="center">
    <img style="width: 35%; height: 35%" src="cv_asl_svg.svg">
</p>

[![DOI](https://zenodo.org/badge/618300539.svg)](https://zenodo.org/badge/latestdoi/618300539)
[![PyPI- to be made, placeholder](https://img.shields.io/pypi/v/cvasl.svg)](https://pypi.python.org/pypi/cvasl/)
[![Sanity](https://github.com/ExploreASL/cvasl/actions/workflows/on-commit.yml/badge.svg)](https://github.com/ExploreASL/cvasl/actions/workflows/on-commit.yml)
[![Citation](https://img.shields.io/badge/Cite%20as-cvasl-blue)](https://github.com/ExploreASL/cvasl/#citation)


**cvasl** is an open source collaborative python library for analysis
of brain MRIs. Many functions relate to arterial spin labeled sequences.



This library
supports the ongoing research at University of Amsterdam Medical Center on brain ageing, but
is being buit for the entire community of radiology researchers across all university and academic medical centers and beyond.


## License

This project is licensed under the Apache-2.0 License - see the [LICENSE](LICENSE) file for details.

## Citation

If you use this software in your research, please cite it. You can find the citation information by clicking the "Cite this repository" button in the sidebar on the right.

```bibtex
@software{Amiri_cvasl_2025,
author = {Amiri, Saba and Kok, Peter and Moore, Candace Makeda and Crocioni, Giulia and Dijsselhof, Mathijs and Mutsaerts, Henk JMM and Petr, Jan and Bodor, Dani},
license = {Apache-2.0},
month = jul,
title = {{cvasl}},
url = {https://github.com/ExploreASL/cvasl},
version = {1.1.0},
year = {2025}
}
```

# Command-Line Interface

You can preprocess, train and use models, and perform harmonization using the command-line interface.


## MRIdataset Class

The `MRIdataset` class in `cvasl.dataset` is designed to load and preprocess MRI datasets for harmonization and analysis. It supports loading data from CSV files, preprocessing steps like feature dropping, categorical encoding, and adding derived features (ICV, decade).

**MRIdataset Initialization Parameters:**

*   `path` (str or list): Path to the CSV file or a list of paths for datasets spanning multiple files (e.g., for datasets like Site0 which might be spread across 'TOP_input.csv' and 'StrokeMRI_input.csv').
*   `site_id` (int or str): Identifier for the data acquisition site. This is crucial for harmonization to distinguish between datasets from different sites.
*   `patient_identifier` (str, optional): Column name that uniquely identifies each patient. Defaults to `"participant_id"`.
*   `features_to_drop` (list, optional): List of feature names (columns) to be dropped from the dataset during preprocessing. Defaults to `["m0", "id"]`.
*   `cat_features_to_encode` (list, optional): List of categorical feature names to be encoded into numerical representations. This is important for harmonizers and models that require numerical input. Defaults to `None`.
*   `ICV` (bool, optional): If `True`, adds Intracranial Volume (ICV) related features, assuming 'gm\_vol' and 'gm\_icvratio' columns are available. Defaults to `False`.
*   `decade` (bool, optional): If `True`, adds a 'decade' feature derived from the 'age' column. Defaults to `False`.
*   `features_to_bin` (list, optional): List of features to be binned. Defaults to `None`.
*   `binning_method` (str, optional): Method for binning, either `"equal_width"` or `"equal_frequency"`. Defaults to `"equal_width"`.
*   `num_bins` (int, optional): Number of bins to create for binning. Defaults to `10`.
*   `bin_labels` (list, optional): Custom labels for the bins. Defaults to `None`.

Example of creating `MRIdataset` objects in `runharmonize.py`:

```python
Site0_path = ['../data/Site001_input.csv','../data/Site002_input.csv']
Site1_path = '../data/Site1_input.csv'
Site2_path = '../data/Site2_input.csv'
Site3_path = '../data/Site3_input.csv'
Site4_path = '../data/Site4_input.csv'

features_to_drop = ["m0", "id"]
features_to_map = ['readout', 'labelling', 'sex']
patient_identifier = 'participant_id'

Site0 = MRIdataset(Site0_path, site_id=3, decade=True, ICV = True, patient_identifier=patient_identifier, features_to_drop=features_to_drop)
Site1 = MRIdataset(Site1_path, site_id=0, decade=True, ICV = True, patient_identifier=patient_identifier, features_to_drop=features_to_drop)
Site2 = MRIdataset(Site2_path, site_id=1, decade=True, ICV = True, patient_identifier=patient_identifier, features_to_drop=features_to_drop)
Site3 = MRIdataset(Site3_path, site_id=2, decade=True, ICV = True, patient_identifier=patient_identifier, features_to_drop=features_to_drop)
Site4 = MRIdataset(Site4_path, site_id=4, decade=True, ICV = True, patient_identifier=patient_identifier, features_to_drop=features_to_drop)

datasets = [Site0, Site1, Site2, Site3, Site4]
[_d.preprocess() for _d in datasets] # Preprocess all datasets
datasets = encode_cat_features(datasets,features_to_map) # Encode categorical features across datasets
```

## Harmonization Methods

The `cvasl.harmonizers` module provides several harmonization techniques to reduce site-specific variance in MRI data. Below is a guide to the available harmonizers and how to run them via the command-line interface using `harmonizer_cli.py`.

### Running Harmonization via CLI

To run harmonization, use the `harmonizer_cli.py` script with the following general command structure:

```bash
python harmonizer_cli.py --dataset_paths <dataset_paths> --site_ids <site_ids> --method <harmonization_method> [harmonizer_specific_options] [dataset_options]
```

*   `--dataset_paths`: Comma-separated paths to your dataset CSV files. For datasets with multiple input paths (like Site0), use semicolons to separate paths within a dataset entry, and commas to separate different datasets (e.g., `path1,path2,"path3;path4",path5`).
*   `--site_ids`: Comma-separated site IDs corresponding to each dataset path provided in `--dataset_paths`.
*   `--method`: The name of the harmonization method to be used. Available methods are: `neuroharmonize`, `covbat`, `neurocombat`, `nestedcombat`, `comscanneuroharmonize`, `autocombat`, `relief`, `combat++`.
*   `[harmonizer_specific_options]`: Placeholders for parameters specific to each harmonization method. These are detailed below for each harmonizer.
*   `[dataset_options]`: Options related to dataset loading and preprocessing, such as `--patient_identifier`, `--features_to_drop`, `--features_to_map`, `--decade`, and `--icv`. These options are common across all harmonizers.

### Harmonization Methods and Example Commands

Below are example commands for each harmonization method. Adjust dataset paths and parameters as needed for your data.

**NeuroHarmonize:**
```bash
python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method neuroharmonize --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --nh_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --nh_covariates age,sex,icv,site --nh_site_indicator site
```

**Covbat:**
```bash
python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method covbat --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --cb_features_to_harmonize participant_id,site,age,sex,site,aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --cb_covariates age,sex --cb_numerical_covariates age --cb_site_indicator site
```

**NeuroCombat:**
```bash
python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method neurocombat --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --nc_features_to_harmonize ACA_B_CoV,MCA_B_CoV,PCA_B_CoV,TotalGM_B_CoV,ACA_B_CBF,MCA_B_CBF,PCA_B_CBF,TotalGM_B_CBF --nc_discrete_covariates sex --nc_continuous_covariates age --nc_site_indicator site
```

**NestedComBat:**
```bash
python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method nestedcombat --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --nest_features_to_harmonize ACA_B_CoV,MCA_B_CoV,PCA_B_CoV,TotalGM_B_CoV,ACA_B_CBF,MCA_B_CBF,PCA_B_CBF,TotalGM_B_CBF --nest_batch_list_harmonisations readout,ld,pld --nest_site_indicator site --nest_discrete_covariates sex --nest_continuous_covariates age --nest_use_gmm False
```

**Combat++:**
```bash
python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method combat++ --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --compp_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --compp_discrete_covariates sex --compp_continuous_covariates age --compp_discrete_covariates_to_remove labelling --compp_continuous_covariates_to_remove ld --compp_site_indicator site
```

**ComscanNeuroHarmonize:**
```bash
python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method comscanneuroharmonize --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --csnh_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --csnh_discrete_covariates sex --csnh_continuous_covariates decade --csnh_site_indicator site
```

**AutoComBat:**
```bash
python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method autocombat --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --ac_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --ac_data_subset aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf,site,readout,labelling,pld,ld,sex,age --ac_discrete_covariates sex --ac_continuous_covariates age --ac_site_indicator site,readout,pld,ld --ac_discrete_cluster_features site,readout --ac_continuous_cluster_features pld,ld
```

**RELIEF:**
```bash
python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method relief --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --relief_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --relief_covariates sex,age --relief_patient_identifier participant_id
```

### Important Notes

*   **Adjust Paths:** Ensure that you replace placeholder paths (e.g., `../data/Site1_input.csv`) with the actual paths to your data files.
*   **Parameter Tuning:** The provided commands use example parameters. You may need to adjust harmonization parameters (features to harmonize, covariates, etc.) based on your dataset and harmonization goals. Consult the documentation or code comments for each harmonizer to understand specific parameter options.
*   **R Requirement:** Methods like `RELIEF` and `Combat++` require R to be installed and accessible in your environment, along with the necessary R packages (`denoiseR`, `RcppCNPy`, `matrixStats`).
*   **Output Files:** Harmonized datasets will be saved as new CSV files in the same directory as your input datasets, with filenames appended with `output_<harmonization_method>`.

By following these guidelines, you can effectively utilize the harmonization functionalities within `cvasl` to process your MRI datasets and mitigate site-related biases.

## Harmonization Guide

This section provides a guide on using the `cvasl` library for MRI data harmonization. It covers the `MRIdataset` class for data loading and preprocessing, and various harmonization methods available in the `cvasl.harmonizers` module.

### MRIdataset Class

The `MRIdataset` class in `cvasl.dataset` is designed to handle MRI datasets from different sites, preparing them for harmonization and analysis.

**Initialization Parameters:**

*   `path` (str or list): Path to the CSV file or a list of paths. For multiple paths, use a list of strings.
*   `site_id` (int or str): Identifier for the data acquisition site.
*   `patient_identifier` (str, optional): Column name for patient IDs. Defaults to `"participant_id"`.
*   `cat_features_to_encode` (list, optional): List of categorical features to encode. Defaults to `None`.
*   `ICV` (bool, optional): Whether to add Intracranial Volume (ICV) related features. Defaults to `False`.
*   `decade` (bool, optional): Whether to add decade-related features based on age. Defaults to `False`.
*   `features_to_drop` (list, optional): List of features to drop during preprocessing. Defaults to `["m0", "id"]`.
*   `features_to_bin` (list, optional): List of features to bin. Defaults to `None`.
*   `binning_method` (str, optional): Binning method to use; `"equal_width"` or `"equal_frequency"`. Defaults to `"equal_width"`.
*   `num_bins` (int, optional): Number of bins for binning. Defaults to `10`.
*   `bin_labels` (list, optional): Labels for bins. Defaults to `None`.

**Usage Example:**

```python
from cvasl.dataset import MRIdataset

Site1 = MRIdataset(path='../data/Site1_input.csv', site_id=0, decade=True, ICV=True, patient_identifier='participant_id', features_to_drop=["m0", "id"])
Site2 = MRIdataset(path='../data/Site2_input.csv', site_id=1, decade=True, ICV=True, patient_identifier='participant_id', features_to_drop=["m0", "id"])
Site0 = MRIdataset(path=['../data/Site001_input.csv','../data/Site002_input.csv'], site_id=3, decade=True, ICV=True, patient_identifier='participant_id', features_to_drop=["m0", "id"])
```

**Preprocessing:**

After initializing `MRIdataset` objects, you can preprocess them using the `preprocess()` method:

```python
datasets = [Site1, Site2, Site0] # Example list of MRIdataset objects
[_d.preprocess() for _d in datasets]
```

**Categorical Feature Encoding:**

For categorical feature encoding across datasets, use the `encode_cat_features` function:

```python
from cvasl.dataset import encode_cat_features

features_to_map = ['readout', 'labelling', 'sex']
datasets = encode_cat_features(datasets, features_to_map)
```

### Harmonization Methods

The `cvasl.harmonizers` module provides several state-of-the-art harmonization methods. Below is a guide to each method and how to run them using the command-line interface (CLI).

**Running Harmonization via CLI:**

The `harmonizer_cli.py` script in `cvasl` allows you to run various harmonization methods from the command line. You need to specify the dataset paths, site IDs, harmonization method, and method-specific parameters.

**General CLI Usage:**

```bash
python harmonizer_cli.py --dataset_paths <dataset_path1>,<dataset_path2>,... --site_ids <site_id1>,<site_id2>,... --method <harmonization_method> [method_specific_options]
```

**Available Harmonization Methods and CLI Commands:**

1.  **NeuroHarmonize:**

    *   Method Class: `NeuroHarmonize`
    *   CLI `--method` value: `neuroharmonize`
    *   Method-specific CLI Options:
        *   `--nh_features_to_harmonize`: Features to harmonize (comma-separated).
        *   `--nh_covariates`: Covariates (comma-separated).
        *   `--nh_smooth_terms`: Smooth terms (comma-separated, optional).
        *   `--nh_site_indicator`: Site indicator column name.
        *   `--nh_empirical_bayes`: Use empirical Bayes (True/False).

    *   **Example Command:**

        ```bash
        python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method neuroharmonize --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --nh_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --nh_covariates age,sex,icv,site --nh_site_indicator site
        ```

2.  **Covbat:**

    *   Method Class: `Covbat`
    *   CLI `--method` value: `covbat`
    *   Method-specific CLI Options:
        *   `--cb_features_to_harmonize`: Features to harmonize (comma-separated).
        *   `--cb_covariates`: Covariates (comma-separated).
        *   `--cb_site_indicator`: Site indicator column name.
        *   `--cb_patient_identifier`: Patient identifier column name.
        *   `--cb_numerical_covariates`: Numerical covariates (comma-separated).
        *   `--cb_empirical_bayes`: Use empirical Bayes (True/False).

    *   **Example Command:**

        ```bash
        python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method covbat --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --cb_features_to_harmonize participant_id,site,age,sex,site,aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --cb_covariates age,sex --cb_numerical_covariates age --cb_site_indicator site
        ```

3.  **NeuroCombat:**

    *   Method Class: `NeuroCombat`
    *   CLI `--method` value: `neurocombat`
    *   Method-specific CLI Options:
        *   `--nc_features_to_harmonize`: Features to harmonize (comma-separated).
        *   `--nc_discrete_covariates`: Discrete covariates (comma-separated).
        *   `--nc_continuous_covariates`: Continuous covariates (comma-separated).
        *   `--nc_site_indicator`: Site indicator column name.
        *   `--nc_patient_identifier`: Patient identifier column name.
        *   `--nc_empirical_bayes`: Use empirical Bayes (True/False).
        *   `--nc_mean_only`: Mean-only adjustment (True/False).
        *   `--nc_parametric`: Parametric adjustment (True/False).

    *   **Example Command:**

        ```bash
        python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method neurocombat --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --nc_features_to_harmonize ACA_B_CoV,MCA_B_CoV,PCA_B_CoV,TotalGM_B_CoV,ACA_B_CBF,MCA_B_CBF,PCA_B_CBF,TotalGM_B_CBF --nc_discrete_covariates sex --nc_continuous_covariates age --nc_site_indicator site
        ```

4.  **NestedComBat:**

    *   Method Class: `NestedComBat`
    *   CLI `--method` value: `nestedcombat`
    *   Method-specific CLI Options:
        *   `--nest_features_to_harmonize`: Features to harmonize (comma-separated).
        *   `--nest_batch_list_harmonisations`: Batch variables for nested ComBat (comma-separated).
        *   `--nest_site_indicator`: Site indicator column name.
        *   `--nest_discrete_covariates`: Discrete covariates (comma-separated).
        *   `--nest_continuous_covariates`: Continuous covariates (comma-separated).
        *   `--nest_intermediate_results_path`: Path for intermediate results.
        *   `--nest_patient_identifier`: Patient identifier column name.
        *   `--nest_return_extended`: Return extended outputs (True/False).
        *   `--nest_use_gmm`: Use Gaussian Mixture Model (True/False).

    *   **Example Command:**

        ```bash
        python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method nestedcombat --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --nest_features_to_harmonize ACA_B_CoV,MCA_B_CoV,PCA_B_CoV,TotalGM_B_CoV,ACA_B_CBF,MCA_B_CBF,PCA_B_CBF,TotalGM_B_CBF --nest_batch_list_harmonisations readout,ld,pld --nest_site_indicator site --nest_discrete_covariates sex --nest_continuous_covariates age --nest_use_gmm False
        ```

5.  **Combat++:**

    *   Method Class: `CombatPlusPlus`
    *   CLI `--method` value: `combat++`
    *   Method-specific CLI Options:
        *   `--compp_features_to_harmonize`: Features to harmonize (comma-separated).
        *   `--compp_discrete_covariates`: Discrete covariates (comma-separated).
        *   `--compp_continuous_covariates`: Continuous covariates (comma-separated).
        *   `--compp_discrete_covariates_to_remove`: Discrete covariates to remove (comma-separated).
        *   `--compp_continuous_covariates_to_remove`: Continuous covariates to remove (comma-separated).
        *   `--compp_site_indicator`: Site indicator column name.
        *   `--compp_patient_identifier`: Patient identifier column name.
        *   `--compp_intermediate_results_path`: Path for intermediate results.

    *   **Example Command:**

        ```bash
        python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method combat++ --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --compp_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --compp_discrete_covariates sex --compp_continuous_covariates age --compp_discrete_covariates_to_remove labelling --compp_continuous_covariates_to_remove ld --compp_site_indicator site
        ```

6.  **ComscanNeuroHarmonize:**

    *   Method Class: `ComscanNeuroCombat`
    *   CLI `--method` value: `comscanneuroharmonize`
    *   Method-specific CLI Options:
        *   `--csnh_features_to_harmonize`: Features to harmonize (comma-separated).
        *   `--csnh_discrete_covariates`: Discrete covariates (comma-separated).
        *   `--csnh_continuous_covariates`: Continuous covariates (comma-separated).
        *   `--csnh_site_indicator`: Site indicator column name.

    *   **Example Command:**

        ```bash
        python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method comscanneuroharmonize --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --csnh_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --csnh_discrete_covariates sex --csnh_continuous_covariates decade --csnh_site_indicator site
        ```

7.  **AutoComBat:**

    *   Method Class: `AutoCombat`
    *   CLI `--method` value: `autocombat`
    *   Method-specific CLI Options:
        *   `--ac_features_to_harmonize`: Features to harmonize (comma-separated).
        *   `--ac_data_subset`: Data subset features (comma-separated).
        *   `--ac_discrete_covariates`: Discrete covariates (comma-separated).
        *   `--ac_continuous_covariates`: Continuous covariates (comma-separated).
        *   `--ac_site_indicator`: Site indicator column name(s), comma-separated if multiple.
        *   `--ac_discrete_cluster_features`: Discrete cluster features (comma-separated).
        *   `--ac_continuous_cluster_features`: Continuous cluster features (comma-separated).
        *   `--ac_metric`: Metric for cluster optimization (`distortion`, `silhouette`, `calinski_harabasz`).
        *   `--ac_features_reduction`: Feature reduction method (`pca`, `umap`, `None`).
        *   `--ac_feature_reduction_dimensions`: Feature reduction dimensions (int).
        *   `--ac_empirical_bayes`: Use empirical Bayes (True/False).

    *   **Example Command:**

        ```bash
        python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method autocombat --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --ac_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --ac_data_subset aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf,site,readout,labelling,pld,ld,sex,age --ac_discrete_covariates sex --ac_continuous_covariates age --ac_site_indicator site,readout,pld,ld --ac_discrete_cluster_features site,readout --ac_continuous_cluster_features pld,ld
        ```

8.  **RELIEF:**

    *   Method Class: `RELIEF`
    *   CLI `--method` value: `relief`
    *   Method-specific CLI Options:
        *   `--relief_features_to_harmonize`: Features to harmonize (comma-separated).
        *   `--relief_covariates`: Covariates (comma-separated).
        *   `--relief_patient_identifier`: Patient identifier column name.
        *   `--relief_intermediate_results_path`: Path for intermediate results.

    *   **Example Command:**

        ```bash
        python harmonizer_cli.py --dataset_paths "../data/Site001_input.csv','../data/Site002_input.csv", ../data/Site1_input.csv,../data/Site2_input.csv,../data/Site3_input.csv,../data/Site4_input.csv --site_ids 0,1,2,3,4 --method relief --patient_identifier participant_id --features_to_drop m0,id --features_to_map readout,labelling,sex --decade True --icv True --relief_features_to_harmonize aca_b_cov,mca_b_cov,pca_b_cov,totalgm_b_cov,aca_b_cbf,mca_b_cbf,pca_b_cbf,totalgm_b_cbf --relief_covariates sex,age --relief_patient_identifier participant_id
        ```

**Note:**  For datasets with multiple paths (like Site0 in the examples), use semicolons (`;`) to separate paths within the `--dataset_paths` argument, while using commas (`,`) to separate different datasets.

✨Copyright 2025 Netherlands eScience Center and U. Amsterdam Medical Center
Licensed under <TBA> See LICENSE for details.✨

# RELIEF

**REmoval of Latent Inter-scanner Effects through Factorization**

R package to apply **RELIEF harmonization** to multi-site or multi-scanner neuroimaging studies. This method has been previously called **UNIFAC harmonization**.

### References

> Zhang, R., Oliver, L. D., Voineskos, A. N., Park, J. Y. (2023). RELIEF: a structured multivariate approach for removal of latent inter-scanner effects. Imaging Neuroscience. [link](https://doi.org/10.1162/imag_a_00011)

### Update logs

> April 27, 2023: RELIEF method implemented in the package.

## Contents

1. [Background](#id-background)
2. [Installation](#id-installation)
3. [Usage](#id-relief)

---

<div id='id-background'/>

### Background
RELIEF supports harmonizing neuroimaging data collected from multiple sites and/or scanners. It is equivalent to the *batch effect correction* in genomic studies. Compared to existing approaches such as ComBat (Johnson *et al*, 2007), RELIEF supports the removal of latent scanner-specific patterns, which results in better data quality after harmonization.


<div id='id-installation'/>

---

### Installation
To install the latest development builds directly from GitHub, please run the followings:

```R
if (!require("devtools"))
  install.packages("devtools")
devtools::install_github("junjypark/RELIEF")
```

Note: If you see an error message, please update your `devtools` package first.

```R
update.packages("devtools")
```

After installation, the package can be loaded directly in R.
```R
library(RELIEF)
``` 

---

<div id='id-relief'/>

### Usage

`relief()` is the main function that takes the same input names as [neuroCombat](https://github.com/Jfortin1/neuroCombat_Rpackage). Specifically, the following need to be provided.

* `dat`: a (p x n) data matrix, where p is the number of features and n is the number of subjects (required)
* `batch`: Batch variable for the scanner id (required)
* `mod`: a (n x q) matrix containing biological covariates (optional). This can be obtained by using `model.matrix()` function in R. However, when you use `mod` in RELIEF, ensure your covariate of interest (for hypothesis testing) is excluded. In practice, RELIEF preserves covariate effects well even though it is not specified as an input.

Now, the `relief` can be applied to obtain the harmonized data.

```R
relief.harmonized = relief(dat=dat, batch=batch, mod=mod)
``` 



---

# CovBat_Harmonization
### Correcting Covariance Batch Effects (CovBat): Harmonization of mean and covariance for multi-site data

--------

**Fork Maintainer**: Candace Makeda Moore, cmoore@netherlandsesciecnecenter.nl

**Original Library Author**: Andrew Chen, andrewac@pennmedicine.upenn.edu

**License**: Artistic License 2.0

## Table of content
- [1. Installation](#id-section1)
- [2. Background](#id-section2)
- [3. Software](#id-section3)
- [4. Citation](#id-section4)

<div id='id-section1'/>

## 1. Fork background
There was an R package, but to get it go back to the library this was forked from. We made this fork to run Python. We therefore chaned the directories of some files. The goal was reproducible code.

<div id='id-section2'/>

## 2. Science Background
According to the original library readme:
"Current harmonization methods often focus on addressing scanner differences in the mean and variance of features. However, machine learning methods employed in multivariate pattern analysis (MVPA) are known to leverage additional properties of the data, including covariance. In our recent [paper](https://doi.org/10.1002/hbm.25688), we show that ComBat, a state-of-the-art method designed to harmonize mean and variance, is unable to fully prevent detection of scanner manufacturer through MVPA in the Alzheimer's Disease Neuroimaging Initiative data. We design CovBat to harmonize the covariance of multivariate features and show that it can almost fully prevent detection of scanner properties.

CovBat is meant to be applied after initial preprocessing of the images to obtain a set of features and before statistical analyses. The application of CovBat is not limited to neuroimaging data; however, it has yet to be tested in other types of data."

<div id='id-section3'/>

## 3. Software
The R implementation of CovBat is based on the [ComBat](https://github.com/Jfortin1/ComBatHarmonization) package. The Python implementation of CovBat is a modification of the ComBat package for Python [here](https://github.com/brentp/combat.py). This is a fork of covbat created for reproducibility. 

<div id='id-section4'/>

## 4. Citation
If you are using CovBat, cite the following article:

> Chen, A. A., Beer, J. C., Tustison, N. J., Cook, P. A., Shinohara, R. T., Shou, H., & Initiative, T. A. D. N. (2022). Mitigating site effects in covariance for machine learning in neuroimaging data. *Human Brain Mapping*, 43(4), 1179–1195. https://doi.org/10.1002/hbm.25688)

# ComBat++ harmonization 

ComBat++ is an extension of ComBat by also modeling non-biological covariates, which we would like to remove from the data. As in Combat, it estimates site-specific location and scale parameters, and accounts for biological covariates. ComBat pools information across features using empirical Bayes to improve the estimation of those parameters for small sample size studies. The details are described in Section 5 in (Wachinger et al., MedIA, https://arxiv.org/abs/2002.05049). 

### ComBat++

The  `combatPP` function is the main function. It requires two mandatory arguments:
- a data matrix (p x n) `dat` for which the p rows are features, and the n columns are participants. 
- a numeric or character vector `batch` of length n indicating the site/scanner/study id. 

For illustration purpose, let's simulate an imaging dataset with n=10 participants, acquired on 2 sites, with 5 participants each, with p=9 variables per scan: 

```r
source("utils.R");
source("combatPP.R")
p <- 8
n <- 10
batch <- c(1,1,1,1,1,2,2,2,2,2) #Batch variable for the scanner id
dat <- matrix(runif(p*n), p, n) #Random Data matrix
```

We consider biological covariates that should be preserved in the harmonization, e.g., age and disease:
```r
age <- c(82,70,68,66,80,69,72,76,74,80) # Continuous variable
disease <- as.factor(c(1,2,1,2,1,2,1,2,1,2)) # Categorical variable
mod <- model.matrix(~age+disease)
```

In ComBat++, we further model non-biological covariates that we would like to remove. This can be known variation from variables like magnetic field strength (MFS) and manufacturer, or unknown variation, which we compute with PCA. In the example, we consider 5 scans on 1.5T and 5 scans on 3.0T machines: 

```r
MFS <- as.factor(c(1,1,1,2,2,2,1,1,2,2)) # Categorical variable
mod_remove <- model.matrix(~ MFS)

prcomps <- princomp(t(dat))
PCs <- predict(prcomps,t(dat))

var_remove <- cbind(mod_remove,PCs[,c(1,2)])
```

With all the variables prepared, we call ComBat++ and have the harmonized data in `data.harmonized$dat.combat`:

```r
data.harmonized <- combatPP( dat=dat, PC=var_remove, mod=mod, batch=batch)
```

The `data.harmonized` object also contains the different parameters estimated by ComBat:
- `gamma.hat` and `delta.hat`: Estimated location and shift (L/S) parameters before empirical Bayes.
- `gamma.star` and `delta.star`: Empirical Bayes estimated L/S parameters.
- `gamma.bar`, `t2`, `a.prior` and `b.prior`: esimated prior distributions parameters.


### References

ComBat++ is published in (https://arxiv.org/abs/2002.05049). It is based on ComBat, which was orgiginally proposed for gene expression data (https://doi.org/10.1093/biostatistics/kxj037) and later applied to neuroimaging (https://doi.org/10.1016/j.neuroimage.2017.11.024). 

# opnested-combat
This is the repository for OPNested, OPNested+GMM, and OPNested-ComBat from the manuscript entitled ["Improved generalized ComBat methods for harmonization of radiomic features" by Horng et al.](https://rdcu.be/cZf2n), published at Nature Scientific Reports. These methods are updates to the algorithms previously published at [generalized-combat](https://github.com/hannah-horng/generalized-combat). All functions needed to implement the methods are in the OPNestedComBat.py file.

## OPNestedComBat
Enables harmonization by multiple imaging parameters. See file comments for more details.

## OPNested+GMM ComBat
Uses Gaussian Mixture Modeling (GMM) to identify scan groupings associated with hidden covariates to better address bimodal feature distributions. OPNested+GMM treats the GMM grouping as a batch variable for harmonization.

## OPNested-GMM ComBat
Uses Gaussian Mixture Modeling (GMM) to identify scan groupings associated with hidden covariates to better address bimodal feature distributions. OPNested-GMM treats the GMM grouping as a clinical covariate for protection during harmonization.

# Example
To illustrate how to use the function file, an example with CAPTK features extracted from the publicly available NSCLC-Radiogenomics dataset has been added.

# Updates
These methods are still a work in progress! Keep an eye out for future updates to the methods. 

# Multi-site harmonization in Python with neuroCombat

[![License: MIT](https://img.shields.io/github/license/Jfortin1/neuroCombat)](https://opensource.org/licenses/MIT) 
[![Version](https://img.shields.io/pypi/v/neuroCombat)](https://pypi.org/project/neuroCombat/)
[![PythonVersion](https://img.shields.io/pypi/pyversions/neuroCombat)]()


This is the maintained and official version of neuroCombat (previously hosted [here](https://github.com/ncullen93/neuroCombat)) introduced in our [our recent paper](https://www.sciencedirect.com/science/article/pii/S105381191730931X).


## Installation

neuroCombat is hosted on PyPI, and the easiest way to install neuroCombat is to use the ```pip``` command:

```
pip install neuroCombat
```

## Usage

The ```neuroCombat``` function performs harmonization 

```python
from neuroCombat import neuroCombat
import pandas as pd
import numpy as np

# Getting example data
# 200 rows (features) and 10 columns (scans)
data = np.genfromtxt('testdata/testdata.csv', delimiter=",", skip_header=1)

# Specifying the batch (scanner variable) as well as a biological covariate to preserve:
covars = {'batch':[1,1,1,1,1,2,2,2,2,2],
          'gender':[1,2,1,2,1,2,1,2,1,2]} 
covars = pd.DataFrame(covars)  

# To specify names of the variables that are categorical:
categorical_cols = ['gender']

# To specify the name of the variable that encodes for the scanner/batch covariate:
batch_col = 'batch'

#Harmonization step:
data_combat = neuroCombat(dat=data,
    covars=covars,
    batch_col=batch_col,
    categorical_cols=categorical_cols)["data"]
```

## Optional arguments

- `eb` : `True` or `False`. Should Empirical Bayes be performed? If `False`, the harmonization model will be fit for each feature separately. This is equivalent to performing a location/shift (L/S) correction to each feature separately (no information pooling across features). 

- `parametric` : `True` or `False`. Should parametric adjustements be performed? `True` by default. 

- `mean_only` : `True` or `False`. Should only be means adjusted (no scaling)? `False` by default

- `ref_batch` : batch name to be used as the reference batch for harmonization. `None` by default, in which case the average across scans/images/sites is taken as the reference batch.

## Output

Since version 0.2.10, the `neuroCombat` function outputs a dictionary with 3 elements:
- `data`: A numpy array of the harmonized data, with the same dimension (shape) as the input data.
- `estimates`: A dictionary of the neuroCombat estimates; useful for visualization and understand scanner effects.
- `info`: A dictionary of the inputs needed for ComBat harmonization (batch/scanner information, etc.)

To simply return the harmonized data, one can use the following:

```
data_combat = neuroCombat(dat=dat, ...)["data"]
```

where `...` are the user-specified arguments needed for harmonization. 
    

#' @export
frob=function(X){ sum(X^2,na.rm=T) }

#' @export
sigma.rmt=function(X){ estim_sigma(X,method="MAD") }

#' @export
softSVD=function(X, lambda){
  svdX=svd(X)
  nuc=pmax(svdX$d-lambda,0)
  out=tcrossprod(svdX$u, tcrossprod( svdX$v,diag(nuc) ))
  return(list(out=out, nuc=sum(nuc)))
}

#' @export
relief=function(dat, batch=NULL, mod=NULL,
                scale.features=T, eps=1e-3, max.iter=1000, verbose=T){
  if (verbose) {
    if (!is.null(mod)){
      q=ncol(mod)
      cat(paste0("[RELIEF] Performing RELIEF harmonization with ", ncol(mod), " covariates\n"))
    }
    else{
      q=0
      cat(paste0("[RELIEF] Performing RELIEF harmonization without covariates\n"))
    }
  }
  if (is.null(batch)){ stop("batch information must be provided\n") }
  p=nrow(dat); n=ncol(dat);
  dat.original=dat
  batch.f=as.factor(batch); batch = as.numeric(batch.f)
  batch.id=unique(batch); n.batch=length(batch.id);batch.f.id=unique(batch.f);
  if (verbose) cat(paste0("[RELIEF] ",n.batch," batch identified\n"))

  Xbeta=gamma=sigma.mat=Matrix(0, p, n)
  batch.covariates=model.matrix(~batch.f-1)

  if (is.null(mod)){
    Xbeta = tcrossprod(apply(dat, 1, mean), rep(1,n))
  }else{
    Px= mod%*%ginv(crossprod(mod), tol=0)%*%t(mod)
    Xbeta= dat%*%Px
  }
  residual1 = dat-Xbeta
  Pb = batch.covariates%*%ginv(crossprod(batch.covariates),tol=0)%*%t(batch.covariates)
  gamma = residual1%*%Pb
  residual2 = residual1-gamma

  if (scale.features){
    sigma.mat=sqrt(rowSums(residual2^2)/(n-n.batch-q))%*%t(rep(1,n))
  } else {
    sigma.mat=1
  }

  dat=residual2/sigma.mat

  sub.batch = unlist(lapply(c(1,n.batch), combn, x = batch.id, simplify = FALSE), recursive = FALSE)

  nvec=rep(NA, n.batch)

  sigma.mat.batch=Matrix(1, p, n)
  for (b in 1:n.batch){
    order.temp.batch=which(batch==batch.id[b])
    nvec[b]=length(order.temp.batch)

    s=sigma.rmt(dat[, order.temp.batch])
    sigma.mat.batch[, order.temp.batch]=sigma.mat.batch[, order.temp.batch]*s
    dat[, order.temp.batch]=dat[, order.temp.batch]/s
  }

  sigma.harnomized=sqrt(sum((unique(as.numeric(sigma.mat.batch))^2)*nvec)/(sum(nvec)))

  lambda.set=matrix(NA, 1,length(sub.batch))
  for (b in 1:length(sub.batch)){
    lambda.set[1,b]=sqrt(p)+sqrt(sum(nvec[sub.batch[[b]]]))
  }

  index.set.batch = lapply(sub.batch, function(b) which(batch %in% b))

  estim = lapply(1:length(sub.batch), function(x) Matrix(0, p, n, sparse = TRUE))

  bool=TRUE
  count=1; crit0=0
  idx=c(1:length(sub.batch))

  if (verbose) {
    cat(paste0("[RELIEF] Start optimizing...\n"))
    pb = txtProgressBar(min = 0, max=max.iter, initial=0, char="-", style = 3)
  }
  while (bool){
    if (verbose){  setTxtProgressBar(pb, count)  }
    crit0.old = crit0
    nuc.temp=matrix(NA,1, length(sub.batch))
    for (b in length(sub.batch):1){
      temp=softSVD( (dat-Reduce("+", estim[-idx[b]]))[,index.set.batch[[b]]],lambda.set[,b])
      estim[[b]][,index.set.batch[[b]]]=temp$out
      nuc.temp[,b]=temp$nuc
    }

    crit0 = 1/2*frob(dat-Reduce("+", estim))+sum(lambda.set*nuc.temp,na.rm=T)
    if (abs(crit0.old-crit0)<eps){ bool=FALSE }
    else if (count==max.iter){ bool=FALSE}
    else{ count = count+1 }
  }

  if (verbose & count<max.iter){
    setTxtProgressBar(pb, max.iter)
    cat(paste0("\n[RELIEF] Convergence reached. Finish harmonizing.\n"))
  }
  if (verbose & count==max.iter){
    cat(paste0("\n[RELIEF] Convergence not reached. Increase max.iter.\n"))
  }

  E=dat-Reduce("+", estim)
  E.scaled=sigma.mat*E
  E.original=sigma.mat*sigma.mat.batch*E
  R=sigma.mat*sigma.mat.batch*estim[[length(index.set.batch)]]
  I=sigma.mat*sigma.mat.batch*Reduce("+", estim[-length(index.set.batch)])
  harmonized=Xbeta+R+sigma.harnomized*E.scaled
  estimates=list(Xbeta=Xbeta,gamma=gamma,sigma.mat=sigma.mat, sigma.mat.batch=as.matrix(sigma.mat.batch),sigma.harnomized=sigma.harnomized, R=as.matrix(R),I=as.matrix(I),E.scaled=as.matrix(E.scaled), E.original=as.matrix(E.original))

  return(list(dat.relief=as.matrix(harmonized),
              estimates=estimates,dat.original=dat.original,
              batch=batch.f))
}

# Authors: Christian Wachinger based on ComBat code by Jean-Philippe Fortin
# The original and present code is under the Artistic License 2.0.
# If using this code, make sure you agree and accept this license. 


combatPP <- function(dat, batch, PC=NULL, mod=NULL, eb=TRUE, verbose=TRUE, parametric=TRUE){
  dat <- as.matrix(dat)
  
  .checkConstantRows <- function(dat){
    sds <- rowSds(dat)
    ns <- sum(sds==0)
    if (ns>0){
      message <- paste0(ns, " rows (features) were found to be constant across samples. Please remove these rows before running ComBat.")
      stop(message)
    }
  }
  .checkConstantRows(dat)
  if (eb){
      if (verbose) cat("[combat] Performing ComBat with empirical Bayes\n")
  } else {
      if (verbose) cat("[combat] Performing ComBat without empirical Bayes (L/S model)\n")
  }
  # make batch a factor and make a set of indicators for batch
  batch <- as.factor(batch)
  batchmod <- model.matrix(~-1+batch)  
  if (verbose) cat("[combat] Found",nlevels(batch),'batches\n')
  
  # A few other characteristics on the batches
  n.batch <- nlevels(batch)
  batches <- lapply(levels(batch), function(x)which(batch==x))
  n.batches <- sapply(batches, length)
  n.array <- sum(n.batches)
  
  #combine batch variable and covariates and PC
  design <- cbind(batchmod,PC,mod)
  
  # check for intercept in covariates, and drop if present
  check <- apply(design, 2, function(x) all(x == 1))
  design <- as.matrix(design[,!check])
  
  # Number of covariates or covariate levels
  if (verbose) cat("[combat] Adjusting for",ncol(design)-ncol(batchmod),'covariate(s) or covariate level(s)\n')
  
  # Check if the design is confounded
  if(qr(design)$rank<ncol(design)){
    if(ncol(design)==(n.batch+1)){
      stop("[combat] The covariate is confounded with batch. Remove the covariate and rerun ComBat.")
    }
    if(ncol(design)>(n.batch+1)){
      if((qr(design[,-c(1:n.batch)])$rank<ncol(design[,-c(1:n.batch)]))){
        stop('The covariates are confounded. Please remove one or more of the covariates so the design is not confounded.')
      } else {
        stop("At least one covariate is confounded with batch. Please remove confounded covariates and rerun ComBat.")
      }
    }
  }
    
  
  ##Standardize Data across features
  if (verbose) cat('[combat] Standardizing Data across features\n')
  B.hat1 <- solve(crossprod(design))
  B.hat1 <- tcrossprod(B.hat1, design)
  B.hat <- tcrossprod(B.hat1, dat)
  #Standarization Model
  grand.mean <- crossprod(n.batches/n.array, B.hat[1:n.batch,])
  var.pooled <- ((dat-t(design%*%B.hat))^2)%*%rep(1/n.array,n.array)
  stand.mean <- crossprod(grand.mean, t(rep(1,n.array)))
  
  if(!is.null(design)){
    tmp <- design;tmp[,c(1:n.batch)] <- 0
    stand.mean <- stand.mean+t(tmp%*%B.hat)
  }	
  s.data <- (dat-stand.mean)/(tcrossprod(sqrt(var.pooled), rep(1,n.array)))
  
  # ComBatPP: updated stand.mean without PC
  if(!is.null(PC)){
    stand.mean <- crossprod(grand.mean, t(rep(1,n.array)))
    n.PC <- dim(PC)[2]
    checkPC <- apply(PC, 2, function(x) all(x == 1))  # all 1 columns removed from design
    numAllOnePC <- sum(checkPC)
    cat("All one columns in PC: ", numAllOnePC, "\n")
    #print(dim(design))
    #print(n.batch+n.PC-numAllOnePC)
    tmp <- design; tmp[,c(1:(n.batch+n.PC-numAllOnePC))] <- 0
    stand.mean <- stand.mean+t(tmp%*%B.hat)
  }
    
  ##Get regression batch effect parameters
  if (eb){
      if (verbose) cat("[combat] Fitting L/S model and finding priors\n")
  } else {
      if (verbose) cat("[combat] Fitting L/S model\n")
  }
  batch.design <- design[,1:n.batch]
  gamma.hat <- tcrossprod(solve(crossprod(batch.design, batch.design)), batch.design)
  gamma.hat <- tcrossprod(gamma.hat, s.data)
  delta.hat <- NULL
  for (i in batches){
    delta.hat <- rbind(delta.hat,rowVars(s.data, cols=i, na.rm=TRUE))
  }

  # Empirical Bayes correction:
  gamma.star <- delta.star <- NULL
  gamma.bar <- t2 <- a.prior <- b.prior <- NULL
  if (eb){
      ##Find Priors
      #gamma.bar <- apply(gamma.hat, 1, mean)
      #t2 <- apply(gamma.hat, 1, var)
      gamma.bar <- rowMeans(gamma.hat)
      t2 <- rowVars(gamma.hat)
      a.prior <- apriorMat(delta.hat)
      b.prior <- bpriorMat(delta.hat)
      
      ##Find EB batch adjustments
      if (parametric){
        if (verbose) cat("[combat] Finding parametric adjustments\n")
        for (i in 1:n.batch){
            temp <- it.sol(s.data[,batches[[i]]],gamma.hat[i,],delta.hat[i,],gamma.bar[i],t2[i],a.prior[i],b.prior[i])
            gamma.star <- rbind(gamma.star,temp[1,])
            delta.star <- rbind(delta.star,temp[2,])
        }
      } else {
        if (verbose) cat("[combat] Finding non-parametric adjustments\n")
        for (i in 1:n.batch){
            temp <- int.eprior(as.matrix(s.data[, batches[[i]]]),gamma.hat[i,], delta.hat[i,])
            gamma.star <- rbind(gamma.star,temp[1,])
            delta.star <- rbind(delta.star,temp[2,])
        }
      }
      
  } 



  
  ### Normalize the Data ###
  if (verbose) cat("[combat] Adjusting the Data\n")
  bayesdata <- s.data
  j <- 1
  for (i in batches){
    if (eb){
        bayesdata[,i] <- (bayesdata[,i]-t(batch.design[i,]%*%gamma.star))/tcrossprod(sqrt(delta.star[j,]), rep(1,n.batches[j]))
    } else {
        bayesdata[,i] <- (bayesdata[,i]-t(batch.design[i,]%*%gamma.hat))/tcrossprod(sqrt(delta.hat[j,]), rep(1,n.batches[j]))
    }
    j <- j+1
  }
  
  bayesdata <- (bayesdata*(tcrossprod(sqrt(var.pooled), rep(1,n.array))))+stand.mean
  return(list(dat.combat=bayesdata, 
    gamma.hat=gamma.hat, delta.hat=delta.hat, 
    gamma.star=gamma.star, delta.star=delta.star, 
    gamma.bar=gamma.bar, t2=t2, a.prior=a.prior, b.prior=b.prior, batch=batch, mod=mod, 
    stand.mean=stand.mean, stand.sd=sqrt(var.pooled)[,1])
  )
}

# This is a copy of the original code from the standard version of the
# sva package that can be found at
# https://bioconductor.org/packages/release/bioc/html/sva.html 
# The original and present code is under the Artistic License 2.0.
# If using this code, make sure you agree and accept this license.  
library(matrixStats)

# Following four find empirical hyper-prior values
aprior <- function(gamma.hat){
	m=mean(gamma.hat)
	s2=var(gamma.hat)
	(2*s2+m^2)/s2
}
bprior <- function(gamma.hat){
	m=mean(gamma.hat)
	s2=var(gamma.hat)
	(m*s2+m^3)/s2
}
postmean <- function(g.hat,g.bar,n,d.star,t2){
	(t2*n*g.hat+d.star*g.bar)/(t2*n+d.star)
}
postvar <- function(sum2,n,a,b){
	(.5*sum2+b)/(n/2+a-1)
}

apriorMat <- function(gamma.hat) {
  m <- rowMeans2(gamma.hat)
  s2 <- rowVars(gamma.hat)
  return((2*s2+m^2)/s2)
}
bpriorMat <- function(gamma.hat) {
  m <- rowMeans2(gamma.hat)
  s2 <- rowVars(gamma.hat)
  return((m*s2+m^3)/s2)
}
# Pass in entire data set, the design matrix for the entire data, the batch means, the batch variances, priors (m, t2, a, b), columns of the data  matrix for the batch. Uses the EM to find the parametric batch adjustments

it.sol  <- function(sdat,g.hat,d.hat,g.bar,t2,a,b,conv=.0001){
	#n <- apply(!is.na(sdat),1,sum)
	n <- rowSums(!is.na(sdat))
	g.old <- g.hat
	d.old <- d.hat
	change <- 1
	count <- 0
	ones <- rep(1,ncol(sdat))

	while(change>conv){
		g.new  <- postmean(g.hat,g.bar,n,d.old,t2)
		#sum2   <- apply((sdat-g.new%*%t(rep(1,ncol(sdat))))^2, 1, sum,na.rm=T)
		#sum2   <- apply((sdat-tcrossprod(g.new, rep(1,ncol(sdat))))^2, 1, sum,na.rm=T)
		sum2 <- rowSums2((sdat-tcrossprod(g.new, ones))^2, na.rm=TRUE)
		d.new  <- postvar(sum2,n,a,b)
		change <- max(abs(g.new-g.old)/g.old,abs(d.new-d.old)/d.old)
		g.old <- g.new
		d.old <- d.new
		count <- count+1
		}
	#cat("This batch took", count, "iterations until convergence\n")
	adjust <- rbind(g.new, d.new)
	rownames(adjust) <- c("g.star","d.star")
	adjust
}


int.eprior <- function(sdat, g.hat, d.hat){
    g.star <- d.star <- NULL
    r <- nrow(sdat)
    for(i in 1:r){
        g <- g.hat[-i]
        d <- d.hat[-i]		
        x <- sdat[i,!is.na(sdat[i,])]
        n <- length(x)
        j <- numeric(n)+1
        dat <- matrix(as.numeric(x), length(g), n, byrow=TRUE)
        resid2 <- (dat-g)^2
        sum2 <- resid2 %*% j
        LH <- 1/(2*pi*d)^(n/2)*exp(-sum2/(2*d))
        LH[LH=="NaN"]=0
        g.star <- c(g.star, sum(g*LH)/sum(LH))
        d.star <- c(d.star, sum(d*LH)/sum(LH))
        ## if(i%%1000==0){cat(i,'\n')}
    }
    adjust <- rbind(g.star,d.star)
    rownames(adjust) <- c("g.star","d.star")
    adjust	
} 



# Create indices for matched samples across sites, for one covariate.
#batch: site, study or scanner covariate
#x: continuous covariate
#xmin: minimum value for x to be considered
#xmax: maximum value for x to be considered
#step=1: step for the grid; must be a positive integer
createMatchingIndices <- function(x, batch, xmin=NULL, xmax=NULL, step=1){

	stopifnot(length(x)==length(batch))
	batches <- unique(batch)
	n.batches <- length(batches)
	x_per_batch <- split(x, f=batch)[batches]
	if (is.null(xmin)) xmin <- min(x)
	if (is.null(xmax)) xmax <- max(x)
	grid <- seq(xmin,xmax,step)
	n.bins <- length(grid)-1

	# Creating count matrix:
	counts <- matrix(0, n.bins, n.batches)
	for (i in 1:n.bins){
		counts[i,] <- unlist(lapply(x_per_batch, function(temp){
			sum(temp >= grid[i] & temp < grid[i+1])
		}))
	}
	mins <- unlist(apply(counts,1,min)) #Minimal count
	indices <- c()

	# Creating indices:
	for (i in 1:n.bins){
		for (j in 1:n.batches){
			min <- mins[i]
			if (min!=0){
				cand <- which(x >= grid[i] & x < grid[i+1] & batch==batches[j])

				if (length(cand) !=1){
					cand <- sample(cand,min) # Sampling at random	
				} 


				indices <- c(indices, cand)
			}
		}
	}
	return(indices)
}

            rm(list = ls())
            source('CVASL_RELIEF.R')            
            library(MASS)
            library(Matrix)
            options(repos = c(CRAN = "https://cran.r-project.org"))
            install.packages("denoiseR", dependencies = TRUE, quiet = TRUE)
            library(denoiseR)
            install.packages("RcppCNPy", dependencies = TRUE, quiet = TRUE)
            library(RcppCNPy)
            data5 <- npyLoad("dat_var_for_RELIEF5.npy")
            covars5 <- read.csv('bath_and_mod_forRELIEF5.csv')
            covars_only5  <- covars5[,-(1:2)]   
            covars_only_matrix5 <-data.matrix(covars_only5)
            relief.harmonized = relief(
                dat=data5,
                batch=covars5$batch,
                mod=covars_only_matrix5
            )
            outcomes_harmonized5 <- relief.harmonized$dat.relief
            write.csv(outcomes_harmonized5, "relief1_for5_results.csv")

is.nan.data.frame <- function(x)
do.call(cbind, lapply(x, is.nan))



#' Estimate sigma
#'
#' This function estimates the standard deviation sigma of the noise of the model where the data are generated from a signal of rank k corrupted by homoscedastic Gaussian noise. 
#' Two estimators are implemented. The first one, named LN, is asymptotically unbiased for sigma in the asymptotic framework where both the number of rows and the number of columns are fixed while the noise variance tends to zero (Low Noise).
#' It is calculated by computing the residuals sum of squares (using the truncated SVD at order k as an estimator) divided by the number of data minus the number of estimated parameters. Thus, it requires as an input the rank k.
#' The second one, MAD (mean absolute deviation) is a robust estimator defined as the ratio of the median of the singular values of X over the square root of the median of the Marcenko-Pastur distribution. It can  be useful when the signal can be considered of low-rank (the rank is very small in comparison to the matrix size).
#' 
#' @param X a data frame or a matrix with numeric entries
#' @param method LN for the low noise asymptotic estimate (it requires to specify the rank k) or MAD for mean absolute deviation
#' @param k integer specifying the rank of the signal only if method = "LN". By default k is estimated using the estim_ncp function of the FactoMineR package 
#' @param  center boolean, to center the data. By default "TRUE". 
#' @return sigma the estimated value
#' @details In the low noise (LN) asymptotic framework,  the estimator requires providing the rank k. Different methods are available in the litterature and if by default the user does not provide any value, we use of the function estim_ncp of the FactoMineR package with the option GCV (see ?estim_ncp).
#' @references Josse, J & Husson, F. (2012). Selecting the number of components in principal component analysis using cross-validation approximations. Computational Statistics & Data Analysis, 6 (56).
#' @references Gavish, M & Donoho, D. L. Optimal Shrinkage of Singular Values.
#' @references Gavish, M & Donoho, D. L. (2014). The Optimal Hard Threshold for Singular Values is 4/sqrt(3). IEEE Transactions on Information Theory, 60 (8), 5040-5053.
#' @references Josse, J. & Husson, F. (2011). Selecting the number of components in PCA using cross-validation approximations.Computational Statististics and Data Analysis. 56 (6), pp. 1869-1879.
#' @seealso \code{\link{estim_ncp}}
#' @seealso \code{\link{LRsim}}
#'  @examples 
#' Xsim <-  LRsim(100, 30, 2, 4)
#' estim_sigma(Xsim$X, 2)


## estim_sigma
estim_sigma <- function(X,
                        k = NA,
                        method = c("LN", "MAD"),
                        center = "TRUE") {
  
  method <- match.arg(method, c("LN","MAD","ln","mad", "Ln","Mad"), several.ok = T)[1]
  method <- tolower(method)
  
  # X <- as.matrix(X)
  
  if(sum(sapply(X, is.numeric)) < ncol(X)){
    stop("all the variables must be numeric")
  }
  
  if(center == "TRUE"){
    X <- scale(X,scale=F)
  }
  
  n = nrow(X) 
  p = ncol(X)
  X[is.nan(X)] <- 0
  X[is.infinite(X)] <- 0
  svdX = svd(X)
  
  # infer unspecified choices
  if(method == "ln" & is.na(k)){
    warning("Since you did not specify k, k was estimated using the FactoMineR estim_ncp function")
    k <- estim_ncp(X, scale = F)$ncp
    print(paste("k = ", k))    
  } 
  
  if(center == "TRUE") {
    N <- (n-1)
  } else {
    N <- n
  }
  
  if((k >= min(N, p))&(method == "ln")){   
    stop("the number k specified has to be smaller than the minimum of the number of rows or columns")
  }
  
  # Begin
  if (method == "ln"){
    
    if(k == 0){
      sigma = sqrt(sum(svdX$d^2)/(N*p))
    } else {                          
      sigma <- sqrt(sum(svdX$d[-c(1:k)]^2)/(N*p  - N*k - p*k + k^2))
    }
  } else {
    beta <- min(n,p)/max(n,p)
    lambdastar <- sqrt( 2*(beta + 1) + 8*beta/((beta + 1 + (sqrt(beta^2 + 14*beta + 1)))))
    wbstar <- 0.56*beta^3 - 0.95*beta^2 + 1.82*beta + 1.43
    sigma <-  median(svdX$d)/(sqrt(max(n,p)) *(lambdastar/wbstar))
  }
  
  return(sigma)
}


#' @export
frob=function(X){ sum(X^2,na.rm=T) }

#' @export
sigma.rmt=function(X){ estim_sigma(X,method="MAD") }

#' @export
softSVD=function(X, lambda){
  X[is.nan(X)] <- 0
  X[is.infinite(X)] <- 0
  svdX=svd(X)
  nuc=pmax(svdX$d-lambda,0)
  out=tcrossprod(svdX$u, tcrossprod( svdX$v,diag(nuc) ))
  return(list(out=out, nuc=sum(nuc)))
}

#' @export
relief=function(dat, batch=NULL, mod=NULL,
                scale.features=T, eps=1e-3, max.iter=1000, verbose=T){
  if (verbose) {
    if (!is.null(mod)){
      q=ncol(mod)
      cat(paste0("[RELIEF] Performing RELIEF harmonization with ", ncol(mod), " covariates\n"))
    }
    else{
      q=0
      cat(paste0("[RELIEF] Performing RELIEF harmonization without covariates\n"))
    }
  }
  if (is.null(batch)){ stop("batch information must be provided\n") }
  p=nrow(dat); n=ncol(dat);
  dat.original=dat
  batch.f=as.factor(batch); batch = as.numeric(batch.f)
  batch.id=unique(batch); n.batch=length(batch.id);batch.f.id=unique(batch.f);
  if (verbose) cat(paste0("[RELIEF] ",n.batch," batch identified\n"))
  Xbeta=gamma=sigma.mat=Matrix(0, p, n)
  batch.covariates=model.matrix(~batch.f-1)


  if (is.null(mod)){
    Xbeta = tcrossprod(apply(dat, 1, mean), rep(1,n))
  }else{
    Px= mod%*%ginv(crossprod(mod), tol=0)%*%t(mod)
    Xbeta= dat%*%Px
  }
  residual1 = dat-Xbeta
  Pb = batch.covariates%*%ginv(crossprod(batch.covariates),tol=0)%*%t(batch.covariates)
  gamma = residual1%*%Pb
  residual2 = residual1-gamma

  if (scale.features){
    sigma.mat=sqrt(rowSums(residual2^2)/(n-n.batch-q))%*%t(rep(1,n))
  } else {
    sigma.mat=1
  }

  dat=residual2/sigma.mat
  sub.batch = unlist(lapply(c(1,n.batch), combn, x = batch.id, simplify = FALSE), recursive = FALSE)
  nvec=rep(NA, n.batch)
  sigma.mat.batch=Matrix(1, p, n)
  for (b in 1:n.batch){
    order.temp.batch=which(batch==batch.id[b])
    nvec[b]=length(order.temp.batch)
    

    s=sigma.rmt(dat[, order.temp.batch])

    sigma.mat.batch[, order.temp.batch]=sigma.mat.batch[, order.temp.batch]*s
    dat[, order.temp.batch]=dat[, order.temp.batch]/s
  }

  sigma.harnomized=sqrt(sum((unique(as.numeric(sigma.mat.batch))^2)*nvec)/(sum(nvec)))
  lambda.set=matrix(NA, 1,length(sub.batch))
  for (b in 1:length(sub.batch)){
    lambda.set[1,b]=sqrt(p)+sqrt(sum(nvec[sub.batch[[b]]]))
  }

  index.set.batch = lapply(sub.batch, function(b) which(batch %in% b))

  estim = lapply(1:length(sub.batch), function(x) Matrix(0, p, n, sparse = TRUE))
  bool=TRUE
  count=1; crit0=0
  idx=c(1:length(sub.batch))

  if (verbose) {
    cat(paste0("[RELIEF] Start optimizing...\n"))
    pb = txtProgressBar(min = 0, max=max.iter, initial=0, char="-", style = 3)
  }
  while (bool){
    if (verbose){  setTxtProgressBar(pb, count)  }
    crit0.old = crit0
    nuc.temp=matrix(NA,1, length(sub.batch))
    for (b in length(sub.batch):1){

      temp=softSVD( (dat-Reduce("+", estim[-idx[b]]))[,index.set.batch[[b]]],lambda.set[,b])
      estim[[b]][,index.set.batch[[b]]]=temp$out
      nuc.temp[,b]=temp$nuc
    }

    crit0 = 1/2*frob(dat-Reduce("+", estim))+sum(lambda.set*nuc.temp,na.rm=T)
    if (abs(crit0.old-crit0)<eps){ bool=FALSE }
    else if (count==max.iter){ bool=FALSE}
    else{ count = count+1 }
  }

  if (verbose & count<max.iter){
    setTxtProgressBar(pb, max.iter)
    cat(paste0("\n[RELIEF] Convergence reached. Finish harmonizing.\n"))
  }
  if (verbose & count==max.iter){
    cat(paste0("\n[RELIEF] Convergence not reached. Increase max.iter.\n"))
  }

  E=dat-Reduce("+", estim)
  E.scaled=sigma.mat*E
  E.original=sigma.mat*sigma.mat.batch*E
  R=sigma.mat*sigma.mat.batch*estim[[length(index.set.batch)]]
  I=sigma.mat*sigma.mat.batch*Reduce("+", estim[-length(index.set.batch)])
  harmonized=Xbeta+R+sigma.harnomized*E.scaled
  estimates=list(Xbeta=Xbeta,gamma=gamma,sigma.mat=sigma.mat, sigma.mat.batch=as.matrix(sigma.mat.batch),sigma.harnomized=sigma.harnomized, R=as.matrix(R),I=as.matrix(I),E.scaled=as.matrix(E.scaled), E.original=as.matrix(E.original))

  return(list(dat.relief=as.matrix(harmonized),
              estimates=estimates,dat.original=dat.original,
              batch=batch.f))
}

#!/bin/bash

# slurm specific parameters
#SBATCH --job-name=aslbrainage
#SBATCH --gres=gpu:a100:1
#SBATCH --partition=luna-gpu-long
#SBATCH --mem=64G
#SBATCH --cpus-per-task=1
#SBATCH --time=6-23:59
#SBATCH --nice=0
#SBATCH --qos=radv
#SBATCH --mail-type=BEGIN

set -eu

export OMP_NUM_THREADS=$SLURM_CPUS_PER_TASK

CSV_FILE="/home/user/training.csv"
IMAGE_DIR="/home/user/training"
NUM_EPOCHS=100
SPLIT_STRATEGY="stratified_group_sex"
BATCH_SIZE=10
LEARNING_RATE=0.0005
BINS=20
OUTPUT_DIR="/home/user/saved_models"

while [[ $# -gt 0 ]]; do
  case $1 in
    --csv_file)
      CSV_FILE="$2"
      shift 2
      ;;
    --image_dir)
      IMAGE_DIR="$2"
      shift 2
      ;;
    --num_epochs)
      NUM_EPOCHS="$2"
      shift 2
      ;;
    --split_strategy)
      SPLIT_STRATEGY="$2"
      shift 2
      ;;
    --batch_size)
      BATCH_SIZE="$2"
      shift 2
      ;;
    --learning_rate)
      LEARNING_RATE="$2"
      shift 2
      ;;
    --bins)
      BINS="$2"
      shift 2
      ;;
    --output_dir)
      OUTPUT_DIR="$2"
      shift 2
      ;;
    -h|--help)
      echo "Usage: $0 [OPTIONS]"
      echo "Options:"
      echo "  --csv_file CSV_FILE           Path to CSV file (default: $CSV_FILE)"
      echo "  --image_dir IMAGE_DIR         Path to image directory (default: $IMAGE_DIR)"
      echo "  --num_epochs NUM_EPOCHS       Number of training epochs (default: $NUM_EPOCHS)"
      echo "  --split_strategy STRATEGY     Data split strategy (default: $SPLIT_STRATEGY)"
      echo "  --batch_size BATCH_SIZE       Training batch size (default: $BATCH_SIZE)"
      echo "  --learning_rate LEARNING_RATE Learning rate (default: $LEARNING_RATE)"
      echo "  --bins BINS                   Number of bins (default: $BINS)"
      echo "  --output_dir OUTPUT_DIR       Output directory for models (default: $OUTPUT_DIR)"
      echo "  -h, --help                    Show this help message"
      exit 0
      ;;
    *)
      echo "Unknown option: $1"
      echo "Use --help for usage information"
      exit 1
      ;;
  esac
done

module load Anaconda3/2024.02-1
module load cuda/12.8
conda activate brainage

run_training() {
  local model_type=$1
  local learning_rate=$2
  shift 2 

  local output_file="log"  # Log file
  local resnet_args=""
  local densenet_args=""
  local hybrid_cnn_args=""
  local resnext_args=""
  local efficientnet_args=""
  local large_cnn_args=""
  local improved_cnn_args=""
    local brainage_args=""

  echo "Training model: ${model_type} with learning rate: ${learning_rate}" >> "$output_file"

  # Conditionally set ResNet arguments

  if [[ "$model_type" == "efficientnet3d" ]]; then
    efficientnet_args="--efficientnet_dropout $1 --efficientnet_width_coefficient $2 --efficientnet_depth_coefficient $3 --efficientnet_initial_filters $4"  # Removed multiplier
    shift 4  # Shift past efficientnet specific args
  fi

  if [[ "$model_type" == "large" ]]; then
    large_cnn_args="--large_cnn_use_bn --large_cnn_use_se --large_cnn_use_dropout --large_cnn_dropout_rate $1 --large_cnn_layers $2 --large_cnn_filters $3 --large_cnn_filters_multiplier $4"
    shift 4 # Shift past the large cnn specific args
  fi

  if [[ "$model_type" == "improved_cnn" ]]; then
    improved_cnn_args="--improved_cnn_use_se --improved_cnn_dropout_rate $1 --improved_cnn_num_conv_layers $2 --improved_cnn_initial_filters $3 --improved_cnn_filters_multiplier $4"
    shift 4 # Shift past the improved cnn specific args
  fi

  if [[ "$model_type" == "hybrid_cnn_transformer" ]]; then
      hybrid_cnn_args="--hybrid_cnn_backbone_type $1 --hybrid_cnn_${1}_layers $2 $3 $4 --hybrid_cnn_initial_filters $5 --hybrid_transformer_layers $6 --hybrid_transformer_heads $7 --hybrid_transformer_ffn_dim $8 --hybrid_transformer_dropout $9"
    if [[ "$1" == "resnet" ]]; then
        hybrid_cnn_args+=" --hybrid_cnn_resnet_filters_multiplier ${10} --hybrid_cnn_resnet_use_se --hybrid_cnn_resnet_dropout"
    elif [[ "$1" == "densenet" ]]; then
         hybrid_cnn_args+=" --hybrid_cnn_densenet_growth_rate ${10} --hybrid_cnn_densenet_transition_filters_multiplier ${11} --hybrid_cnn_densenet_use_se --hybrid_cnn_densenet_dropout"
    fi
      shift 11
  fi

    # BrainAgeLoss arguments.
    local alpha=$1
    local beta=$2
    local gamma=$3
    local smoothing=$4
    local use_huber=$5
    shift 5
    brainage_args="--brainage_alpha $alpha --brainage_beta $beta --brainage_gamma $gamma --brainage_smoothing $smoothing"

    if [[ "$use_huber" == "True" ]]; then
        brainage_args+=" --brainage_use_huber --brainage_delta $1"
        shift 1
    fi
    


  
  python train.py \
    --model_type "$model_type" \
    --csv_file "$CSV_FILE" \
    --image_dir "$IMAGE_DIR" \
    --num_epochs "$NUM_EPOCHS" \
    --batch_size "$BATCH_SIZE" \
    --learning_rate "$learning_rate" \
    --bins "$BINS" \
    --use_wandb \
    --wandb_prefix lossopt \
    --use_cuda \
    --store_model \
    --split_strategy "$SPLIT_STRATEGY" \
    --output_dir "$OUTPUT_DIR" \
    $resnet_args $densenet_args $resnext_args $efficientnet_args $large_cnn_args $improved_cnn_args $hybrid_cnn_args $brainage_args "$@" 2>&1 | tee -a "$output_file"

  # Check exit status.
  if [ $? -ne 0 ]; then
    echo "Training FAILED for model: ${model_type} with learning rate: $learning_rate" >> "$output_file"
  else:
    echo "Training SUCCESSFUL for model: ${model_type} with learning rate: $learning_rate" >> "$output_file"
  fi
}

# Main script execution

# Create the output directory.
mkdir -p saved_models_test

# Clear the log file.
> log

# Learning rates to loop through
learning_rates=(0.0005)
learning_rates2=(0.0005)


loss_params=(
  # Baseline (MAE)
  "0.0 0.0 0.0 0.0 False"

  # Individual Component Tests (as before, but with Huber variants)

  # Exploring different Huber deltas (with a moderate combination)
  "0.5 0.2 0.1 0.0 True 0.5"  # Lower delta (more like MAE)
  "0.5 0.2 0.1 0.0 True 2.0"  # Higher delta (more robust)

  # Combined Effects (Varying Alpha - Corerlation Loss)
  "0.1 0.1 0.1 0.0 False"  # low Alpha
  "2.0 0.1 0.1 0.0 False"  # Very high alpha (emphasize correlation)

  # Combined Effects (Varying Beta - Bias Regularization)
  "0.5 0.05 0.1 0.0 False" # Low BEta
  "0.5 1.0 0.1 0.0 False"  # Very High Beta (emphasize std dev matching)

  # Combined Effects (Varying Gamma - Age-Specific Weighting)
  "0.5 0.1 0.05 0.0 False" # low gamma
  "0.5 0.1 1.0 0.0 False"  # Very High Gamma (emphasize older ages)

  # Combined Effects (with Huber Loss, delta=1.0)
  "0.1 0.1 0.1 0.0 True 1.0"  # Low Combination (Huber)
  "0.5 0.2 0.1 0.0 True 1.0"  # Moderate combination (Huber) - a good starting point
  "1.0 0.3 0.2 0.0 True 1.0"  # Higher combination (Huber) - Your "All" from before.
  "2.0 0.5 0.5 0.0 True 1.0" # High Alpha and Beta with Huber

  # Exploring Smoothing (with a moderate combination)
  "0.5 0.2 0.1 0.1 False"  # Low smoothing
  "0.5 0.2 0.1 0.5 False"    # high smoothing
  "0.5 0.2 0.1 0.1 True 1.0" # low smoothing huber
  "0.5 0.2 0.1 0.5 True 1.0"    # high smoothing huber
  
)
    # Loop through each learning rate
for lr in "${learning_rates[@]}"; do
    # --- Large CNN ---
    for dropout_rate in 0.05 0.08; do
        for layers in 4 6; do
            for filters in 8; do
                for multiplier in 1.5; do
                    for loss_param in "${loss_params[@]}"; do
                      echo "Running large CNN with dropout rate: $dropout_rate, layers: $layers, filters: $filters, multiplier: $multiplier, loss params: $loss_param"
                      run_training "large" "$lr" $dropout_rate $layers $filters $multiplier $loss_param
                  done
                done
            done
        done
    done

    for dropout_rate in 0.05 0.1; do
        for layers in 6 8; do
            for filters in 8 10; do
                for multiplier in 0.8; do
                    for loss_param in "${loss_params[@]}"; do
                        echo "Running improved CNN with dropout rate: $dropout_rate, layers: $layers, filters: $filters, multiplier: $multiplier, loss params: $loss_param"
                        run_training "improved_cnn" "$lr" $dropout_rate $layers $filters $multiplier $loss_param
                    done
                done
            done
        done
    done
done


echo "All model training attempts completed.  See 'log' for details."

#!/bin/bash

# slurm specific parameters
#SBATCH --job-name=aslbrainage
#SBATCH --gres=gpu:a100:1
#SBATCH --partition=luna-gpu-long
#SBATCH --mem=64G
#SBATCH --cpus-per-task=1
#SBATCH --time=6-23:59
#SBATCH --nice=0
#SBATCH --qos=radv
#SBATCH --mail-type=BEGIN

set -eu

DEFAULT_TRAINING_CSV="./data/training.csv"
DEFAULT_TEST_CSVS="./data/test1.csv ./data/test2.csv"
DEFAULT_TRAINING_IMG_DIR="./data/training_images"
DEFAULT_TEST_IMG_DIRS="./data/test1_images ./data/test2_images"
DEFAULT_MODEL_DIR="./saved_models"
DEFAULT_MASK_PATHS="./data/masks"
DEFAULT_STATS_OUTPUT_ROOT="./statistical_results"
DEFAULT_INDICES_PATH="./data/test_indices.npy"
DEFAULT_XAI_OUTPUT_DIR="./xai_results"
DEFAULT_XAI_METHOD="all"
DEFAULT_DEVICE="cuda"
DEFAULT_ATLAS_PATH="./atlases/HarvardOxford-sub-maxprob-thr25-2mm.nii.gz"
DEFAULT_INDIVIDUAL_PATIENTS=""

while [[ $# -gt 0 ]]; do
    case $1 in
        --training-csv)
            TRAINING_CSV="$2"
            shift 2
            ;;
        --test-csvs)
            TEST_CSVS="$2"
            shift 2
            ;;
        --training-img-dir)
            TRAINING_IMG_DIR="$2"
            shift 2
            ;;
        --test-img-dirs)
            TEST_IMG_DIRS="$2"
            shift 2
            ;;
        --model-dir)
            MODEL_DIR="$2"
            shift 2
            ;;
        --mask-paths)
            MASK_PATHS="$2"
            shift 2
            ;;
        --stats-output-root)
            STATS_OUTPUT_ROOT="$2"
            shift 2
            ;;
        --indices-path)
            INDICES_PATH="$2"
            shift 2
            ;;
        --xai-output-dir)
            XAI_OUTPUT_DIR="$2"
            shift 2
            ;;
        --xai-method)
            XAI_METHOD="$2"
            shift 2
            ;;
        --device)
            DEVICE="$2"
            shift 2
            ;;
        --atlas-path)
            ATLAS_PATH="$2"
            shift 2
            ;;
        --individual-patients)
            INDIVIDUAL_PATIENTS="--individual_patients"
            shift
            ;;
        *)
            echo "Unknown parameter: $1"
            exit 1
            ;;
    esac
done

TRAINING_CSV=${TRAINING_CSV:-$DEFAULT_TRAINING_CSV}
TEST_CSVS=${TEST_CSVS:-$DEFAULT_TEST_CSVS}
TRAINING_IMG_DIR=${TRAINING_IMG_DIR:-$DEFAULT_TRAINING_IMG_DIR}
TEST_IMG_DIRS=${TEST_IMG_DIRS:-$DEFAULT_TEST_IMG_DIRS}
MODEL_DIR=${MODEL_DIR:-$DEFAULT_MODEL_DIR}
MASK_PATHS=${MASK_PATHS:-$DEFAULT_MASK_PATHS}
STATS_OUTPUT_ROOT=${STATS_OUTPUT_ROOT:-$DEFAULT_STATS_OUTPUT_ROOT}
INDICES_PATH=${INDICES_PATH:-$DEFAULT_INDICES_PATH}
XAI_OUTPUT_DIR=${XAI_OUTPUT_DIR:-$DEFAULT_XAI_OUTPUT_DIR}
XAI_METHOD=${XAI_METHOD:-$DEFAULT_XAI_METHOD}
DEVICE=${DEVICE:-$DEFAULT_DEVICE}
ATLAS_PATH=${ATLAS_PATH:-$DEFAULT_ATLAS_PATH}
INDIVIDUAL_PATIENTS=${INDIVIDUAL_PATIENTS:-$DEFAULT_INDIVIDUAL_PATIENTS}

export OMP_NUM_THREADS=$SLURM_CPUS_PER_TASK

module load Anaconda3/2024.02-1
module load cuda/12.8
conda activate brainage

read -a test_csv_array <<< "$TEST_CSVS"
read -a test_img_array <<< "$TEST_IMG_DIRS"
read -a mask_path_array <<< "$MASK_PATHS"

echo "Running statistical analysis..."
python test_stats.py \
    --validation_csv "$TRAINING_CSV" "${test_csv_array[@]}" \
    --validation_img_dir "$TRAINING_IMG_DIR" "${test_img_array[@]}" \
    --model_dir "$MODEL_DIR" \
    --mask_path "${mask_path_array[@]}" \
    --output_root "$STATS_OUTPUT_ROOT" \
    --indices_path "$INDICES_PATH" $(printf "None %.0s" $(seq 1 ${#test_csv_array[@]}))

echo "Running XAI analysis..."
for i in "${!test_csv_array[@]}"; do
    test_csv="${test_csv_array[$i]}"
    test_dir="${test_img_array[$i]}"
    dataset_name=$(basename "$test_csv" .csv)
    
    echo "Processing dataset: $dataset_name"
    python xai.py \
        --models_dir "$MODEL_DIR" \
        --test_csv "$test_csv" \
        --test_data_dir "$test_dir" \
        --output_dir "$XAI_OUTPUT_DIR/$(basename $MODEL_DIR)_$dataset_name" \
        --method "$XAI_METHOD" \
        --device "$DEVICE" \
        --atlas_path "$ATLAS_PATH" \
        $INDIVIDUAL_PATIENTS
done
